<!DOCTYPE html>
<html>

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- font -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="css/stylemin.css">
  <link rel="stylesheet" href="css/color.css">
  <title> Pizza 365 v0.9</title>
</head>

<body onload="onPageLoading()">
  <!-- Menu -->
  <div class="container-fluid">
    <div class="row">
      <div class="col-sm-12">
        <nav class="navbar fixed-top navbar-expand-lg navbar-light bg-light">
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
            aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="navbar-nav nav-fill w-100">
              <li class="nav-item active">
                <a class="nav-link" href="#">HOME</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#combo">SIZE COMBOS</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#type">PIZZA TYPES</a>
              </li>
              <li class="nav-item">
                <a class="nav-link" href="#contact">FORM CONTACT</a>
              </li>
            </ul>
          </div>
        </nav>
      </div>
    </div>
  </div>

  <!-- Content -->
  <div class="container" style="padding: 70px 0px 50px 0px">
    <div class="row">
      <div class="col-sm-12">
        <div class="row">
          <!-- Title row home -->
          <div class="col-sm-12">
            <h1><b class="text-main">Pizza 365</b></h1>
            <p style="font-style: italic" class="text-second">Truly italian!</p>
          </div>

          <!-- Slide row home -->
          <div class="col-sm-12">
            <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
              <ol class="carousel-indicators">
                <li data-target="#carouselExampleIndicators" data-slide-to="0" class="active"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="1"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="2"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="3"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="4"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="5"></li>
                <li data-target="#carouselExampleIndicators" data-slide-to="6"></li>
              </ol>
              <div class="carousel-inner">
                <div class="carousel-item active">
                  <img class="d-block w-100" src="images/anh_mon_1.jpg" alt="First slide" />
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/anh_mon_2.jpg" alt="Second slide" />
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/anh_mon_3.jpg" alt="Third slide" />
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/anh_mon_4.jpg" alt="Fourth slide" />
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/anh_mon_5.jpg" alt="Fifth slide" />
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/anh_mon_6.jpg" alt="Sixth slide" />
                </div>
                <div class="carousel-item">
                  <img class="d-block w-100" src="images/anh_mon_7.jpg" alt="Seventh slide" />
                </div>
              </div>
              <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
              </a>
              <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
              </a>
            </div>
          </div>

          <!-- Title ưu điểm của Quán -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Tại sao lại Pizza 365</b></h2>
          </div>

          <!-- Content ưu điểm của Quán -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-3 p-3 bg-brand-01 text-white border">
                <h3 class="p-2">Không ngừng cải tiến</h3>
                <p class="p-2">Cải tiến sản phẩm, chất lượng và trải nghiệm khách hàng luôn là yếu tố tiên quyết trong
                  chiến lược kinh doanh của chúng tôi nhằm thúc đẩy tăng trưởng và trở thành thương hiệu pizza hàng đầu.
                </p>
              </div>
              <div class="col-sm-3 p-3 bg-brand-02 text-white border">
                <h3 class="p-2">Trải nghiệm dễ dàng</h3>
                <p class="p-2">Chúng tôi đơn giản hướng đến việc trở thành thương hiệu của mọi nhà, mọi lúc, mọi nơi.
                </p>
              </div>
              <div class="col-sm-3 p-3 bg-brand-03 text-white border">
                <h3 class="p-2">Hướng đến sự vượt trội</h3>
                <p class="p-2">"Vượt trội" không chỉ là một khái niệm lớn. Thay vào đó, giá trị này là cốt lõi trong mỗi
                  con người của chúng tôi, trong mỗi công việc mà họ làm.</p>
              </div>
              <div class="col-sm-3 p-3 bg-brand-04 text-white border">
                <h3 class="p-2">Thể hiện đam mê</h3>
                <p class="p-2">Chúng tôi sẵn lòng hỗ trợ vô điều kiện và linh động điều chỉnh tùy theo thử thách để tìm
                  ra giải pháp.</p>
              </div>
            </div>
          </div>
        </div>

        <div id="combo" class="row">
          <!-- Title Size Combos -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-1 border-bottom">Menu combo Pizza 365</b></h2>
            <p><span class="p-2">Hãy chọn combo phù hợp với bạn</span></p>
          </div>
          <!-- Content các Size Combos -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-main-brand text-white text-center">
                    <h3>S ( Small size)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">
                        Đường kính <b> 20 cm</b>
                      </li>
                      <li class="list-group-item">Sườn nướng <b>2</b></li>
                      <li class="list-group-item">Salad <b>200 gr</b></li>
                      <li class="list-group-item">Nước ngọt <b>2</b></li>
                      <li class="list-group-item">
                        <h1>VND <b>150,000</b></h1>
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button class="btn-green" id="btn-size-small" data-is-selected="N" onclick="onBtnSmallSizeClick()">
                      Chọn
                    </button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-main-brand text-white text-center">
                    <h3>M (Medium size)</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">
                        Đường kính <b> 25 cm</b>
                      </li>
                      <li class="list-group-item">Sườn nướng <b>4</b></li>
                      <li class="list-group-item">Salad <b> 300 gr</b></li>
                      <li class="list-group-item">Nước ngọt <b>3</b></li>
                      <li class="list-group-item">
                        <h1>VND <b>200,000</b></h1>
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button class="btn-green" id="btn-size-medium" data-is-selected="N"
                      onclick="onBtnMediumSizeClick()"> Chọn </button>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card">
                  <div class="card-header bg-main-brand text-white text-center">
                    <h3>L ( Large size )</h3>
                  </div>
                  <div class="card-body text-center">
                    <ul class="list-group list-group-flush">
                      <li class="list-group-item">
                        Đường kính <b> 30 cm</b>
                      </li>
                      <li class="list-group-item">Sườn nướng <b>8</b></li>
                      <li class="list-group-item">Salad <b> 500 gr</b></li>
                      <li class="list-group-item">Nước ngọt <b>4</b></li>
                      <li class="list-group-item">
                        <h1>VND <b>250,000</b></h1>
                      </li>
                    </ul>
                  </div>
                  <div class="card-footer text-center">
                    <button class="btn-green" id="btn-size-large" data-is-selected="N" onclick="onBtnLargeSizeClick()">
                      Chọn </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="type" class="row">
          <!-- Title Pizza Type -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Chọn loại pizza</b></h2>
          </div>

          <!-- Content Pizza Type -->
          <div class="col-sm-12">
            <div class="row">
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem">
                  <img src="images/pizza_type_hawai.jpg" class="card-img-top" />
                  <div class="card-body">
                    <h3>Pizza Hawai</h3>
                    <p>Món ăn thanh đạm</p>
                    <p>
                      Hãy thưởng thức món ăn với phong cách Alo Ha đến từ
                      Hawai.
                    </p>
                    <p>
                      <button class="btn-green" id="btn-type-hawai" data-is-selected="N"
                        onclick="onBtnHawaiPizzaTypeClick()"> Chọn </button>
                    </p>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem">
                  <img src="images/pizza_type_hai_san.jpg" class="card-img-top" />
                  <div class="card-body">
                    <h3>Pizza Hải sản</h3>
                    <p>Món ăn đến từ biển</p>
                    <p>
                      Bạn đã thử pizza được chế biến từ nguyên liệu hải sản chưa ?
                    </p>
                    <p>
                      <button class="btn-green" id="btn-type-hai-san" data-is-selected="N"
                        onclick="onBtnHaiSanPizzaTypeClick()"> Chọn </button>
                    </p>
                  </div>
                </div>
              </div>
              <div class="col-sm-4">
                <div class="card w-100" style="width: 18rem">
                  <img src="images/pizza_type_thit_nuong.jpg" class="card-img-top" />
                  <div class="card-body">
                    <h3>Pizza Bacon</h3>
                    <p>Món ăn đăc biệt</p>
                    <p>
                      Được chế biến từ thịt bacon. Mang đến hương vị mới lạ.
                    </p>
                    <p>
                      <button class="btn-green" id="btn-type-bacon" data-is-selected="N"
                        onclick="onBtnBaconPizzaTypeClick()"> Chọn </button>
                    </p>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="drink" class="row">
          <!-- Title Drink Type -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Đồ uống</b></h2>
          </div>
          <!-- Content Drink Type -->
          <div class="col-sm-12 p-2 jumbotron">
            <div class="row">
              <div class="col-sm-12">
                <div class="form-group">
                  <!-- Task 25.30: Thêm sự kiện change khi click vào option trong Đồ Uống select element -->
                  <select name="the-drink" id="select-the-drink" class="form-control" onchange="onSelectBeverageChange()">
                    <option value="0">Chọn đồ uống</option>
                  </select>
                </div>
              </div>
            </div>
          </div>
        </div>

        <div id="contact" class="row">
          <!-- Title Form Contact Us -->
          <div class="col-sm-12 text-center p-4 mt-4">
            <h2><b class="p-2 border-bottom">Thông tin đơn hàng</b></h2>
          </div>

          <!-- Content Form Contact Us -->
          <div class="col-sm-12 p-2 jumbotron">
            <div class="row">
              <div class="col-sm-12">
                <div class="form-group">
                  <label for="input-name">Họ và tên</label>
                  <input type="text" class="form-control" id="input-name" placeholder="Họ và tên" />
                </div>
                <div class="form-group">
                  <label for="email">Email</label>
                  <input type="text" class="form-control" id="input-email" placeholder="Email" />
                </div>
                <div class="form-group">
                  <label for="input-phone">Điện thoại</label>
                  <input type="text" class="form-control" id="input-phone" placeholder="Điện thoại" />
                </div>
                <div class="form-group">
                  <label for="input-address">Địa chỉ</label>
                  <input type="text" class="form-control" id="input-address" placeholder="Địa chỉ" />
                </div>
                <div class="form-group">
                  <label for="input-message">Lời nhắn</label>
                  <input type="text" class="form-control" id="input-message" placeholder="Lời nhắn" />
                </div>
                <div class="form-group">
                  <label for="input-voucher-id">Mã giảm giá (Voucher ID)</label>
                  <input type="text" class="form-control" id="input-voucher-id" placeholder="Mã voucher..." />
                </div>
                <button type="button" class="btn-green" onclick="onBtnCheckOrderClick()"> Kiểm tra đơn </button>

              </div>
            </div>
          </div>
          <!-- vùng hiển thị thông tin đơn hàng(order) -->
          <div id="div-container-order" class="container bg-info p-2 jumbotron" style="display: none">
            <div id="div-order-infor" class="text-white p-3">thông tin đơn hàng vào đây</div>
            <div class="p-2">
              <!-- sử dụng this.data.donHang để gán giá trị của đối tượng paramDonHang vào thuộc tính data.donHang và lưu trữ giá trị của DonHang -->
              <button type="button" id="btn-send-order" class="btn-yellow" onclick="onBtnSendOrderClick(this.dataset.donHang)"> Gửi đơn </button>
            </div>
          </div>
          <div id="div-order-code" class="container p-2 jumbotron p-4 custom-div-order-code" style="display: none">
            <h4 id="gratitude" class="col-md-12 text-black">Cảm ơn bạn đã đặt hàng tại Pizza 365. Mã đơn hàng của bạn là:</h4>
            <div class="row mt-4">
              <div class="col-sm-3 ml-4 mt-3"><h4> Mã đơn hàng:</h4></div>
              <div id="order-code" class="col-sm-7 p-3">
                <h4 id="order-code-h4"></h4>
              </div>
              <div class="col-sm-3"></div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Footer -->
  <div class="container-fluid bg-light p-3">
    <div class="row text-center">
      <div class="col-sm-12">
        <h4 class="m-2">Footer</h4>
        <a href="#" class="btn bg-main-brand text-white m-3"><i class="fa fa-arrow-up mr-2"></i>To the top</a>
        <div class="m-2">
          <i class="fa fa-facebook-official text-main"></i>
          <i class="fa fa-instagram text-main"></i>
          <i class="fa fa-snapchat text-main"></i>
          <i class="fa fa-pinterest-p text-main "></i>
          <i class="fa fa-twitter text-main"></i>
          <i class="fa fa-linkedin text-main"></i>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gSMALL_SIZE = "S ( Small size)";
  const gMEDIUM_SIZE = "M (Medium size)";
  const gLARGE_SIZE = "L ( Large size )";
  const gHAWAI_PIZZA_TYPE = "Pizza Hawai";
  const gHAISAN_PIZZA_TYPE = "Pizza Hải sản";
  const gBACON_PIZZA_TYPE = "Pizza Bacon";
  const gBEVERAGE_BASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
  const gVOUCHER_BASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/";
  const gORDER_API_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  const gREQUEST_STATUS_OK = 200; // GET & PUT success
  const gREQUEST_CREATE_STATUS_OK = 201;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gJSON_CONTENT_TYPE = "application/json;charset=UTF-8";

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm sự kiện tải lại trang
  function onPageLoading() {
    // B1: đọc dữ liệu <không cần làm>
    // B2: kiểm tra dữ liệu
    // B3: gọi API, lấy JSON, chuyển ra Object
    // tải (đổ) dữ liệu Đồ Uống vào thẻ Select Chọn Đồ Uống
    loadDataIntoTheDrinkSelect();
  }

  // hàm sự kiện kiểm tra đơn đặt Pizza
  function onBtnCheckOrderClick() {
    // gọi hàm khởi tạo đối tượng nguyên thủy để gán giá trị vào cho đối tượng DonHang
    var vDonHang = getOrderObjectStructure();

    /* Qui trình kiểm tra đơn: chia thành 3 bước xử lý
      (1) Thu thập dữ liệu
      (2) Kiểm tra dữ liệu, cảnh báo (alert) nếu cần
      (3) Xử lý hiển thị
    */
    // Bước 1: Thu thập dữ liệu
    getDatOnForm(vDonHang);
    console.log(vDonHang);

    // Bước 2: Kiểm tra dữ liệu
    var vChecked = validateData(vDonHang);
    console.log("Dữ liệu nhập vào đúng hay sai (true/false): " + `%c${vChecked}`, `color:orange`);

    // Bước 3: Xử lý hiển thị
    if (vChecked) {  // nếu validate không có lỗi
      // gọi hàm displayTheOrder để hiển thị thông tin đơn hàng
      displayOrderInfor(vDonHang);
    }
  }

  // Hàm sự kiện chọn Pizza size Small khi click vào button
  function onBtnSmallSizeClick() {
    // tạo một đối tượng Pizza
    var vMenu = getSizeCombo(gSMALL_SIZE, "20cm", 2, "200 gr", 2, 150000);
    // gọi method hiển thị thông tin
    vMenu.displayInConsoleLog();
    // đổi màu button chọn Pizza
    changeSizeComboColorButton(gSMALL_SIZE);
  }

  // Hàm sự kiện chọn Pizza size Medium khi click vào button
  function onBtnMediumSizeClick() {
    // tạo một đối tượng Pizza
    var vMenu = getSizeCombo(gMEDIUM_SIZE, "25cm", 4, "300 gr", 3, 200000);
    // gọi method hiển thị thông tin
    vMenu.displayInConsoleLog();
    // đổi màu button chọn Pizza
    changeSizeComboColorButton(gMEDIUM_SIZE);
  }

  // Hàm sự kiện chọn Pizza size Large khi click vào button
  function onBtnLargeSizeClick() {
    // tạo một đối tượng Pizza
    var vMenu = getSizeCombo(gLARGE_SIZE, "30cm", 8, "500 gr", 4, 250000);
    // gọi method hiển thị thông tin
    vMenu.displayInConsoleLog();
    // đổi màu button chọn Pizza
    changeSizeComboColorButton(gLARGE_SIZE);
  }

  /* Các hàm sự kiện cho chọn loại Pizza */
  // hàm sự kiện chọn loại Pizza Hawai khi click vào button
  function onBtnHawaiPizzaTypeClick() {
    // tạo một đối tượng loại Pizza
    var vPizzaType = getPizzaType(gHAWAI_PIZZA_TYPE, "Món ăn thanh đạm", "Hãy thưởng thức món ăn với phong cách Alo Ha đến từ Hawai.");
    // gọi method hiển thị loại Pizza
    vPizzaType.displayPizzaType();
    // đổi màu button khi chọn loại Pizza
    changePizzaTypeColorButton(gHAWAI_PIZZA_TYPE);
  }

  // hàm sự kiện chọn loại Pizza Hải sản khi click vào button
  function onBtnHaiSanPizzaTypeClick() {
    var vPizzaType = getPizzaType(gHAISAN_PIZZA_TYPE, "Món ăn đến từ biển", "Bạn đã thử pizza được chế biến từ nguyên liệu hải sản chưa ?");
    vPizzaType.displayPizzaType();
    // đổi màu button khi chọn loại Pizza
    changePizzaTypeColorButton(gHAISAN_PIZZA_TYPE);
  }

  // hàm sự kiện chọn loại Pizza Bacon khi click vào button
  function onBtnBaconPizzaTypeClick() {
    var vPizzaType = getPizzaType(gBACON_PIZZA_TYPE, "Món ăn đặc biệt", "Được chế biến từ thịt bacon. Mang đến hương vị mới lạ.");
    vPizzaType.displayPizzaType();
    // đổi màu button khi chọn loại Pizza
    changePizzaTypeColorButton(gBACON_PIZZA_TYPE);
  }

  // hàm sự kiện khi nhấn vào button "Gửi đơn" -> Ghi ra console tất cả thông tin đơn hàng
  // input: đối tượng paramDonHang đã được lưu trước đó ở nút button Gửi Đơn (dưới dạng JSON)
  // output: <không>
  function onBtnSendOrderClick(paramDonHangJSON) {
    // chuyển đổi giá trị của thuộc tính 'data-Donhang' từ chuỗi JSON thành một chuỗi Javascript đế xử lý như đối tượng
    var vDonHangObject = JSON.parse(paramDonHangJSON);
    console.log("%c----- Thông tin đơn hàng khi bấm nút Gửi Đơn -----", "color:blue");
    console.log(vDonHangObject);

    /* Task 32.20 Tạo đơn hàng - Dành cho Khách hàng (User) */
    // Gọi API để thêm mới đơn hàng
    var vXmlHttp = new XMLHttpRequest();
    callAPIToCreateNewOrderForUser(vXmlHttp, paramDonHangJSON);
    vXmlHttp.onreadystatechange = function() {
      if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_STATUS_OK) {
        displayOrderCode(vXmlHttp);
      }
    }
  }

  // hàm sự kiện trả về Mã Đồ Uống khi chọn 1 option cụ thể trong thẻ Select Đồ Uống
  function onSelectBeverageChange() {
    // truy xuất đến phần tử Beverage select
    var vBeverageSelectEle = document.getElementById("select-the-drink");
    // Lấy value của option khi click chọn đồ uống
    var vSelectedBeverageID = vBeverageSelectEle.value;
    return vSelectedBeverageID;
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  /* hàm khởi tạo một đối tượng để lưu dữ liệu mỗi khi xử lý trên form
    input: <không>
    output: đối tượng DonHang với dữ liệu nguyên thủy (chưa có giá trị)
  */
  function getOrderObjectStructure() {
    // Khai báo và khởi tạo đối tượng đơn hàng (order)
    var vDonHang = {
      menuDuocChon: null,
      loaiPizza: "",
      loaiNuocUong: "", // Task 25.30: thêm thuộc tính Loại Nước Uống
      hoVaTen: "",
      email: "",
      dienThoai: "",
      diaChi: "",
      loiNhan: "",
      voucher: "",
      phanTramGiamGia: 0,
      // truyền vào phương thức tham số thực chứa các giá trị của đơn hàng đã được lấy từ form
      priceAnnualVND: function (voucher, phanTramGiamGia, priceVND) {
        if(voucher === "Không" && phanTramGiamGia == 0) {
          return priceVND;
        }
        else {
          return (priceVND - (priceVND * phanTramGiamGia * 0.01)); // thực hiện logic tính tiền phải trả
        }
      }
    }
    return vDonHang;
  }

  // hàm trả về một đối tượng Pizza
  // input: các tham số chứa thông tin của kích cỡ Combo khi đặt Pizza
  // output: đối tượng chứa các thông tin của kích cỡ Combo Pizza
  function getSizeCombo(paramKichCo, paramDuongKinhCM, paramSuonNuong, paramSaladGr, paramDrink, paramPriceVND) {
    var vMenu = {
      kichCo: paramKichCo,
      duongKinhCM: paramDuongKinhCM,
      suonNuong: paramSuonNuong,
      saladGr: paramSaladGr,
      drink: paramDrink,
      priceVND: paramPriceVND,
      displayInConsoleLog() { // hiển thị thông tin kích cỡ combo ra console
        console.log("%c----- MENU: SIZE COMBO -----", "color: blue");
        console.log("Kích cỡ: " + this.kichCo);
        console.log("Đường kính: " + this.duongKinhCM);
        console.log("Sườn nướng: " + this.suonNuong);
        console.log("Salad: " + this.saladGr);
        console.log("Nước ngọt: " + this.drink);
        console.log("Giá: " + this.priceVND);
      }
    };
    // trả về đối tượng Pizza
    return vMenu;
  }

  // hàm trả về một đối tượng loại Pizza
  // input: các tham số chứa thông tin của loại Pizza cần đặt
  // output: đối tượng chứa các thông tin của loại Pizza
  function getPizzaType(paramPizzaName, paramDacTinh, paramMoTa) {
    var vPizzaType = {
      pizzaName: paramPizzaName,
      dacTinh: paramDacTinh,
      moTa: paramMoTa,
      displayPizzaType() {
        console.log("%c----- LOẠI PIZZA ĐƯỢC CHỌN -----", "color: blue");
        console.log(this.pizzaName);
        console.log("Đặc tính của Pizza: " + this.dacTinh);
        console.log("Mô tả: " + this.moTa);
      }
    };
    // trả về đối tượng loại Pizza
    return vPizzaType;
  }

  // hàm trả về một đối tượng Nước Uống
  // input: tham số chứa các thông tin của loại Nước Uống
  // output: Nước Uống object
  function getBeverage(paramMaNuocUong, paramTenNuocUong, paramDonGia, paramGhiChu) {
    var vBeverage = {
      beverageID: paramMaNuocUong,
      beverageName: paramTenNuocUong,
      donGia: paramDonGia,
      ghiChu: paramGhiChu,
      displayBeverage() {
        console.log("%c----- LOẠI ĐỒ UỐNG ĐƯỢC CHỌN -----", "color: blue");
        console.log("Mã đồ uống: " + this.beverageID);
        console.log("Tên đồ uống: " + this.beverageName);
        console.log("Đơn giá: " + this.donGia);
        console.log("Ghi chú: " + this.ghiChu);
      }
    }
    return vBeverage;
  }

  /* Hàm đổi màu button chọn Pizza để phân biệt Pizza được chọn với các loại Pizza khác
  input: paramPizza có thể là loại Small, Medium hoặc Large
  output: <không>
  hoạt động: ấn nút nào thì nút đó đổi màu vàng, 2 nút còn lại chuyển màu xanh
  và đánh dấu thuộc tính data-is-selected
  */
  function changeSizeComboColorButton(paramPizza) {
    // truy xuất đến các phần tử Pizza
    var vBtnSmallSize = document.getElementById("btn-size-small");
    var vBtnMediumSize = document.getElementById("btn-size-medium");
    var vBtnLargeSize = document.getElementById("btn-size-large");

    if (paramPizza === gSMALL_SIZE) {
      // đổi màu button
      vBtnSmallSize.className = "btn-yellow";
      vBtnMediumSize.className = "btn-green";
      vBtnLargeSize.className = "btn-green";
      // set thuộc tính để đánh dấu Pizza đã được chọn
      vBtnSmallSize.setAttribute("data-is-selected", "Y");
      vBtnMediumSize.setAttribute("data-is-selected", "N");
      vBtnLargeSize.setAttribute("data-is-selected", "N");
    }
    else if (paramPizza === gMEDIUM_SIZE) {
      // đổi màu button
      vBtnMediumSize.className = "btn-yellow";
      vBtnSmallSize.className = "btn-green";
      vBtnLargeSize.className = "btn-green";
      // set thuộc tính để đánh dấu Pizza đã được chọn
      vBtnMediumSize.setAttribute("data-is-selected", "Y");
      vBtnSmallSize.setAttribute("data-is-selected", "N");
      vBtnLargeSize.setAttribute("data-is-selected", "N");
    }
    else if (paramPizza === gLARGE_SIZE) {
      // đổi màu button
      vBtnLargeSize.className = "btn-yellow";
      vBtnMediumSize.className = "btn-green";
      vBtnSmallSize.className = "btn-green";
      // set thuộc tính để đánh dấu Pizza đã được chọn
      vBtnLargeSize.setAttribute("data-is-selected", "Y");
      vBtnMediumSize.setAttribute("data-is-selected", "N");
      vBtnSmallSize.setAttribute("data-is-selected", "N");
    }
  }

  /* Hàm đổi màu button chọn Pizza để phân biệt loại Pizza được chọn với các loại Pizza khác
  input: paramPizzaType có thể là loại Pizza Hawai, Hải sản hoặc Bacon
  output: <không>
  hoạt động: ấn nút nào thì nút đó đổi màu vàng, 2 nút còn lại chuyển màu xanh
  và đánh dấu thuộc tính data-is-selected
  */
  function changePizzaTypeColorButton(paramPizzaType) {
    // truy xuất đến các phần tử Pizza
    var vBtnHawai = document.getElementById("btn-type-hawai");
    var vBtnHaiSan = document.getElementById("btn-type-hai-san");
    var vBtnBacon = document.getElementById("btn-type-bacon");

    if (paramPizzaType === gHAWAI_PIZZA_TYPE) {
      // đổi màu button
      vBtnHawai.className = "btn-yellow";
      vBtnHaiSan.className = "btn-green";
      vBtnBacon.className = "btn-green";
      // set thuộc tính để đánh dấu Pizza đã được chọn
      vBtnHawai.setAttribute("data-is-selected", "Y");
      vBtnHaiSan.setAttribute("data-is-selected", "N");
      vBtnBacon.setAttribute("data-is-selected", "N");
    }
    else if (paramPizzaType === gHAISAN_PIZZA_TYPE) {
      // đổi màu button
      vBtnHawai.className = "btn-green";
      vBtnHaiSan.className = "btn-yellow";
      vBtnBacon.className = "btn-green";
      // set thuộc tính để đánh dấu Pizza đã được chọn
      vBtnHawai.setAttribute("data-is-selected", "N");
      vBtnHaiSan.setAttribute("data-is-selected", "Y");
      vBtnBacon.setAttribute("data-is-selected", "N");
    }
    else if (paramPizzaType === gBACON_PIZZA_TYPE) {
      // đổi màu button
      vBtnHawai.className = "btn-green";
      vBtnHaiSan.className = "btn-green";
      vBtnBacon.className = "btn-yellow";
      // set thuộc tính để đánh dấu Pizza đã được chọn
      vBtnHawai.setAttribute("data-is-selected", "N");
      vBtnHaiSan.setAttribute("data-is-selected", "N");
      vBtnBacon.setAttribute("data-is-selected", "Y");
    }
  }

  // hàm lấy dữ liệu người dùng nhập trên form
  function getDatOnForm(paramDonHang) {
    // truy xuất đến các phần tử HTML trên form
    var vHoTenInput = document.getElementById("input-name");
    var vEmailInput = document.getElementById("input-email");
    var vDienThoaiInput = document.getElementById("input-phone");
    var vDiaChiInput = document.getElementById("input-address");
    var vLoiNhanInput = document.getElementById("input-message");
    var vMaGiamGiaInput = document.getElementById("input-voucher-id");

    // gán giá trị trên form cho từng thuộc tính của đối tượng Order (đơn hàng)
    paramDonHang.hoVaTen = vHoTenInput.value.trim();
    paramDonHang.email = vEmailInput.value.trim();
    paramDonHang.dienThoai = vDienThoaiInput.value.trim();
    paramDonHang.diaChi = vDiaChiInput.value.trim();
    paramDonHang.loiNhan = vLoiNhanInput.value.trim();
    paramDonHang.voucher = vMaGiamGiaInput.value.trim();

    // lấy thông tin menu được chọn (dựa vào thuộc tính data-is-selected)
    var vBtnSmallSize = document.getElementById("btn-size-small");
    var vBtnMediumSize = document.getElementById("btn-size-medium");
    var vBtnLargeSize = document.getElementById("btn-size-large");
    // lấy giá trị data-is-selected của từng button để biết menu nào được chọn
    var vSmallSizeDaChon = vBtnSmallSize.getAttribute("data-is-selected");
    var vMediumSizeDaChon = vBtnMediumSize.getAttribute("data-is-selected");
    var vLargeSizeDaChon = vBtnLargeSize.getAttribute("data-is-selected");
    /* kiểm tra có phải menu (size combo) được chọn hay không, 
      nếu phải lưu vào thuộc tính "menuDuocChon" của đối tượng vDonHang */
    if (vSmallSizeDaChon === "Y") {
      // lưu đối tượng menu vào đối tượng Order
      paramDonHang.menuDuocChon = getSizeCombo(gSMALL_SIZE, "20cm", 2, "200 gr", 2, 150000);
    }
    else if (vMediumSizeDaChon === "Y") {
      // lưu đối tượng menu vào đối tượng Order
      paramDonHang.menuDuocChon = getSizeCombo(gMEDIUM_SIZE, "25cm", 4, "300 gr", 3, 200000);
    }
    else if (vLargeSizeDaChon === "Y") {
      // lưu đối tượng menu vào đối tượng Order
      paramDonHang.menuDuocChon = getSizeCombo(gLARGE_SIZE, "30cm", 8, "500 gr", 4, 250000);
    }

    // lấy thông tin loại Pizza được chọn (dựa vào thuộc tính data-is-selected)
    var vBtnHawai = document.getElementById("btn-type-hawai");
    var vBtnHaiSan = document.getElementById("btn-type-hai-san");
    var vBtnBacon = document.getElementById("btn-type-bacon");
    // lấy giá trị data-is-selected của từng button để biết menu nào được chọn
    var vHawaiPizzaDaChon = vBtnHawai.getAttribute("data-is-selected");
    var vHaiSanPizzaDaChon = vBtnHaiSan.getAttribute("data-is-selected");
    var vBaconPizzaDaChon = vBtnBacon.getAttribute("data-is-selected");
    /* kiểm tra có phải Loại Pizza được chọn hay không, 
      nếu phải lưu vào thuộc tính "loaiPizza" của đối tượng vDonHang */
    if (vHawaiPizzaDaChon === "Y") {
      // lấy giá trị của tên Pizza Hawai để gán cho thuộc tính loại pizza
      paramDonHang.loaiPizza = gHAWAI_PIZZA_TYPE;
    }
    else if (vHaiSanPizzaDaChon === "Y") {
      // lấy giá trị của tên Pizza Hải Sản để gán cho thuộc tính loại pizza
      paramDonHang.loaiPizza = gHAISAN_PIZZA_TYPE;
    }
    else if (vBaconPizzaDaChon === "Y") {
      // lấy giá trị của tên Pizza Bacon để gán cho thuộc tính loại pizza
      paramDonHang.loaiPizza = gBACON_PIZZA_TYPE;
    }

    // Lấy giá trị của Mã Nước Uống gán cho thuộc tính maNuocUong cua đối tượng Đơn Hàng
    paramDonHang.loaiNuocUong = onSelectBeverageChange();
    
    // trả về toàn bộ đối tượng đơn hàng để ghi ra console khi nhắn vào button "Gửi đơn"
    return paramDonHang;
  }

  // hàm kiểm tra dữ liệu nhập vào từ form
  // input: đối tượng đã được fill giá trị
  // output: true/false (kết quả khi kiểm tra các điều kiện hoặc các hàm validate)
  function validateData(paramDonHang) {
    // Khởi tạo biến kiểm tra điều kiện đúng hoặc sai
    var vChecked = true;

    // 1. Các trường thông tin không rỗng
    // Nếu hợp lệ, mới cho kiểm tra các điều kiện khác
    if (paramDonHang.hoVaTen == "" || paramDonHang.email == "" || paramDonHang.dienThoai == "" || paramDonHang.diaChi == "") {
      alert("Các trường thông tin không được rỗng.");
      vChecked = false;
    }
    else {
      // 2. Menu (kích cỡ): Phải có một loại menu được chọn
      if (paramDonHang.menuDuocChon == null) {
        alert("Bạn phải chọn 1 menu (size combo).");
        vChecked = false;
      }
      // 3. Loại pizza: Phải có một loại Pizza đã được chọn
      if (paramDonHang.loaiPizza == "") {
        alert("Bạn phải chọn 1 loại Pizza.");
        vChecked = false;
      }
      // 4. Email: phải đúng định dạng emai
      if (!validateEmail(paramDonHang.email)) {
        alert("Email không đúng định dạng.");
        vChecked = false;
      }
      // 5. Số điện thoại phải nhập là số, có dấu + hoặc số 0 ở đầu; độ dài từ 10 đến 12 ký tự
      if(!validatePhoneNumber(paramDonHang.dienThoai)) {
        vChecked = false;
      }
    }
    return vChecked;
  }

  // hàm kiểm tra email hải đúng định dạng email
  // input: email cần kiểm tra
  // output: true/false (kết quả kiểm tra định dạng của email)
  function validateEmail(paramEmail) {
    var vRegexEmail = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|.(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{1,}))$/;
    var vChecked = false;
    if (paramEmail && paramEmail.match(vRegexEmail)) {
      vChecked = true;
    }
    return vChecked;
  }

  // hàm kiểm tra số điện thoại
  // input: số điện thoại cần kiểm tra
  // output: true/false (kết quả kiểm tra các điều kiện của số điện thoại)
  function validatePhoneNumber(paramPhone) {
    var vChecked = true;
    // 1. Kiểm tra số điện thoại phải là số
    if (isNaN(paramPhone)) {
      alert("Số điện thoại phải là số");
      vChecked = false;
    }

    // 2. Số điện thoại phải có ký tự bắt đầu là '0' hoặc '+'
    if(paramPhone.charAt(0) !== '0' && paramPhone.charAt(0) !== '+') {
      alert("Ký tự đầu của số điện thoại phải có dấu + hoặc số 0");
      vChecked = false;
    }

    // 3. Số điện thoại phải có chiều dài từ 10 đến 12 ký tự
    if(paramPhone.length < 10 || paramPhone.length > 12) {
      alert("Số điện thoại phải có độ dài từ 10 đến 12 ký tự");
      vChecked = false;
    }
    return vChecked;
  }

  // hàm kiểm tra Mã giảm giá của khách hàng hợp lệ hay không
  // input: <không>
  // output: trả về giá trị của VoucherID
  /* Task 25.30: Sửa lại logic checkVoucherByVoucherID
    - Khống sử dụng mảng các Voucher có sẵn mà sẽ check voucherId có tồn tại hay không thông qua API
    http://203.171.20.210:8080/devcamp-pizza365/voucher_detail + mã voucherId được nhập từ form
    - hàm trả về giá trị tìm thấy kiểu Boolean (true/false) và đã gán giá trị của voucher và phần trăm giảm giá vào đối tượng Đơn Hàng
  */
  function checkVoucherByVoucherID(paramDonHang) {
    var vTimThayVoucherID = false;
    // truy xuất đến phần tử Mã Giảm Giá (Voucher ID)
    var vVoucherIdInput = document.getElementById("input-voucher-id");
    // Tạo đối tượng XMLHttpRequest để gọi API lấy thông tin voucher từ Server
    var vXmlHttp = new XMLHttpRequest();
    // Gọi API (truyền vào tham số là giá trị VoucherID từ ô nhập)
    vXmlHttp.open("GET", gVOUCHER_BASE_URL + vVoucherIdInput.value, false);
    vXmlHttp.send();
    if(vXmlHttp.status == gREQUEST_STATUS_OK) {
      // Chuyển Voucher JSON responseText về object
      var vVoucherObject = JSON.parse(vXmlHttp.responseText);
      // Lưu nội dung voucher và phần trăm giảm giá vào đối tượng Đơn Hàng
      paramDonHang.voucher = vVoucherObject.maVoucher;
      paramDonHang.phanTramGiamGia = vVoucherObject.phanTramGiamGia;
      vTimThayVoucherID = true;
    }
    else {
      alert("Mã giảm giá không tồn tại");
    }
    return vTimThayVoucherID;
  }

  // hàm hiển thị thông tin đơn hàng ra vùng màu xanh trên giao diện
  function displayOrderInfor(paramDonHang) {
    // lấy giá tiền sau khi tính toán (nếu Voucher được tìm thấy)
    var vLastedPrice = passDataToPriceAnnualVNDMethod(paramDonHang);

    /* Hiển thị thông tin đơn hàng ra vùng div chỉ định */
    // truy xuất đến vùng div cần hiển thị thông tin
    var vContent = document.getElementById("div-order-infor");
    // Load dữ liệu lên bằng việc gán giá trị cho nội dung thẻ div (innerHTML)
    vContent.innerHTML = `
    Họ và tên: ${paramDonHang.hoVaTen} </br>
    Email: ${paramDonHang.email} </br>
    Số điện thoại: ${paramDonHang.dienThoai} <br>
    Địa chỉ: ${paramDonHang.diaChi} <br>
    Lời nhắn: ${paramDonHang.loiNhan} <br>
    ------------------------ <br>
    Kích cỡ: ${paramDonHang.menuDuocChon.kichCo} <br>
    Đường kính: ${paramDonHang.menuDuocChon.duongKinhCM} <br>
    Sườn nướng: ${paramDonHang.menuDuocChon.suonNuong} <br>
    Salad: ${paramDonHang.menuDuocChon.saladGr} <br>
    Nước ngọt: ${paramDonHang.menuDuocChon.drink} <br>
    Loại nước uống: ${paramDonHang.loaiNuocUong} <br>
    ------------------------ <br>
    Loại Pizza: ${paramDonHang.loaiPizza} <br>
    Mã voucher: ${paramDonHang.voucher} <br>
    Giá vnd: ${paramDonHang.menuDuocChon.priceVND} <br>
    Discount %: ${paramDonHang.phanTramGiamGia} <br>
    Phải thanh toán vnd: ${vLastedPrice} <br>
    `;
    // truy xuất đến phần tử div bao bên ngoài (hiển thị màu nền cho nội dung)
    var vDivContainer = document.getElementById("div-container-order");
    vDivContainer.style.display = "block";

    // gọi hàm sendOrderData và truyền đối tượng paramDonHang đã có tất cả thông tin vào button 'Gửi Đơn'
    sendOrderData(paramDonHang);
  }

  // hàm truyền các giá trị sau khi check VoucherID đến phương thức PriceAnnualVND để xử lý tính giá tiền Pizza
  // input: tham số thực chứa thông tin DonHang
  // output: giá tiền Pizza sau khi xử lý tính toán
  function passDataToPriceAnnualVNDMethod(paramDonHang) {
    // khởi tạo biến lưu data giá tiền
    var vLastedPrice = 0; 
    // nếu hàm checkVoucherByVoucherID trả về true, nghĩa là VoucherID có tồn tại
    if (checkVoucherByVoucherID(paramDonHang) == true) { // tìm thấy voucherID
      // gọi phương thức priceAnnualVND của đối tượng vDonHang và truyền tham số thực vào để tính giá tiền
      vLastedPrice = paramDonHang.priceAnnualVND(paramDonHang.voucher, paramDonHang.phanTramGiamGia, paramDonHang.menuDuocChon.priceVND);
    }
    else {
      // nếu mã voucher người dùng nhập không hợp lệ, gán giá trị cho ô Mã giảm giá là 'Không'
      paramDonHang.voucher = "Không";
      // vẫn gọi phương thức priceAnnualVND để thực hiện việc không áp dụng phần trăm giám giá
      vLastedPrice = paramDonHang.priceAnnualVND(paramDonHang.voucher, paramDonHang.phanTramGiamGia, paramDonHang.menuDuocChon.priceVND);
    }
    return vLastedPrice;
  }

  // hàm trả về tất cả thông tin của đối tượng DonHang
  // input: đối tượng DonHang sau khi lấy lại dữ liệu từ form
  // output: đối tượng đơn hàng chứa tất cả thông tin sau khi xử lý nghiệp vụ
  function sendOrderData(paramDonHang) {
    // khởi tạo một biến đối tượng Order (14 thuộc tính) để Create New Order
    var vLastedDonHang = generateNewOrderObjectToCreateOrder(paramDonHang);
    // truy cập đến phần tử HTML của nút button Gửi Đơn
    var vBtnGuiDon = document.getElementById("btn-send-order");
    // gán giá trị đối tượng paramDonHang vào thuộc tính dataset-donHang của phần tử button Gửi Đơn
    // ý nghĩa: dùng JSON.stringify(paramDonHang) để chuyển đổi đối tượng paramDonHang thành một chuỗi JSON, vì thuộc tính `data-*` chỉ có thể lưu trữ các giá trị chuỗi
    vBtnGuiDon.dataset.donHang = JSON.stringify(vLastedDonHang);
    // trả về đối tượng DonHang sau khi xử lý tất cả nghiệp vụ
    return vLastedDonHang;
  }

  // Task 25.20
  // hàm đổ dữ liệu Đồ Uống vào thẻ Select tương ứng
  function loadDataIntoTheDrinkSelect() {
    // Tạo đối tượng XMLHttpRequest để tương tác với Server
    var vXmlHttp = new XMLHttpRequest();
    vXmlHttp.open("GET", gBEVERAGE_BASE_URL, true);
    vXmlHttp.send();
    vXmlHttp.onreadystatechange = function() {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          // chuyển chuỗi JSON responseText về dạng Object
          var vDrinkObj = JSON.parse(vXmlHttp.responseText);
          // B4: Xử lý hiển thị dữ liệu khi đã gọi API thành công
          // truy xuất đến phần tử HTML Select Đồ Uống
          var vTheDrinkElement = document.getElementById("select-the-drink");
          // dùng vòng lặp for để thực hiện load từng phần tử Đồ Uống vào thẻ Select
          for(var bIndex = 0; bIndex < vDrinkObj.length; bIndex ++) {
            var vDrinkOption = document.createElement("option");
            vDrinkOption.value = vDrinkObj[bIndex].maNuocUong;
            vDrinkOption.text = vDrinkObj[bIndex].tenNuocUong;
            vTheDrinkElement.add(vDrinkOption);
          }
        }
    };
  }

  // Hàm gọi API để tạo mới Đơn Hàng cho khách hàng
  // input: đối tượng XMLHttpRequest để tương tác với Server và chuỗi JSON Đơn Hàng
  function callAPIToCreateNewOrderForUser(paramXmlHttp, paramOrderJSON) {
    paramXmlHttp.open("POST", gORDER_API_URL, true);
    paramXmlHttp.setRequestHeader("Content-Type", gJSON_CONTENT_TYPE);
    paramXmlHttp.send(paramOrderJSON);
  }

  // Hàm hiển thị Order Code sau khi nhấn nút button 'Gửi Đơn'
  // input: đối tượng XMLHttpRequest để tương tác với Server
  function displayOrderCode(paramXmlHttp) {
    // Chuyển đổi JSON String sang Object
    var vOrderObject = JSON.parse(paramXmlHttp.responseText);
    // Khai báo biến lưu giá trị orderCode
    var vOrderCode = "";
    // Gán giá trị Order Code trong đối tượng Order trả về từ Server
    vOrderCode = vOrderObject.orderCode;
    // Truy xuất thành phần thẻ h4 chứa nội dung orderCode
    var vOrderCodeH4 = document.getElementById("order-code-h4");
    vOrderCodeH4.innerHTML = vOrderCode;

    // Truy xuất đến phần tử div bao bên ngoài (hiển thị màu nền cho nội dung)
    var vDivContainer = document.getElementById("div-container-order");
    // Ẩn phần màu xanh (thông tin đơn hàng)
    vDivContainer.style.display = "none";

    // Truy xuất đến vùng div hiển thị orderCode
    var vOrderCodeDiv = document.getElementById("div-order-code");
    // Hiển thị phần Cảm ơn kèm Mã đơn hàng
    vOrderCodeDiv.style.display = "block";
  }

  // Hàm khởi tạo đối tượng Order và lưu nội dung (14 thuộc tính)
  // input: đối tượng Order sau khi thu thập dữ liệu từ Web
  // output: đối tượng Order (gồm 14 thuộc tính) sau khi gán giá trị
  function generateNewOrderObjectToCreateOrder(paramOrder) {
    var vNewOrderObj = {
      kichCo: paramOrder.menuDuocChon.kichCo,
      duongKinh: paramOrder.menuDuocChon.duongKinhCM,
      suon: paramOrder.menuDuocChon.suonNuong,
      salad: paramOrder.menuDuocChon.saladGr,
      loaiPizza: paramOrder.loaiPizza,
      idVourcher: paramOrder.voucher,
      idLoaiNuocUong: paramOrder.loaiNuocUong,
      soLuongNuoc: paramOrder.menuDuocChon.drink,
      hoTen: paramOrder.hoVaTen,
      // lấy giá tiền sau khi tính toán (nếu Voucher được tìm thấy)
      thanhTien: passDataToPriceAnnualVNDMethod(paramOrder),
      email: paramOrder.email,
      soDienThoai:paramOrder.dienThoai,
      diaChi: paramOrder.diaChi,
      loiNhan: paramOrder.loiNhan
    }
    return vNewOrderObj;
  }

</script>

</html>